@import '~@angular/material/theming';

@mixin style-theme($theme) {
  $p: map-get($theme, primary);
  $a: map-get($theme, accent);
  $w: map-get($theme, warn);
  $b: map-get($theme, background);
  $f: map-get($theme, foreground);
  $primary: mat-color($p);
  $accent: mat-color($a);
  $warn: mat-color($w);
  $background: mat-color($b, background);
  $background-card: mat-color($b, card);
  $foreground: mat-color($f, text);
  $app-bar: mat-color($b, app-bar);
  $primary-contrast: mat-color($p, default-contrast);
  $accent-contrast: mat-color($a, default-contrast);
  $warn-contrast: mat-color($w, default-contrast);

  .color.primary {
    color: $primary;
  }

  .color.accent {
    color: $accent;
  }

  .color.warn {
    color: $warn;
  }

  .background.primary {
    background-color: $primary;
    color: $primary-contrast;
  }

  .background.accent {
    background-color: $accent;
    color: $accent-contrast;
  }

  .background.warn {
    background-color: $warn;
    color: $warn-contrast;
  }

  .background.card {
    background-color: $background-card;
  }

  .background.stacked {
    background-color: $background;
  }

  .bordered {
    border: 1px solid $primary;
  }

  .link {
    font-weight: bolder;
    cursor: pointer;
    color: $primary;
  }

  .link:hover {
    color: $accent;
  }

  sidepanel mat-nav-list.mat-nav-list {
    padding-top: 0px;
    background-color: $app-bar;
  }

  mat-paginator.mat-paginator {
    background-color: $background;
  }

  a.mat-list-item.active,
  a.mat-tab-link.active {
    color: $primary;
  }

  .foreground {
    color: $foreground;
  }
}

$light-blue: mat-palette($mat-light-blue, A400);
$red: mat-palette($mat-red);
$deep-orange: mat-palette($mat-deep-orange, A200);
$pink: mat-palette($mat-red, A100);
$crimson: mat-palette($mat-red, A400);

/*-- Dark Theme Colors --*/
$green-dark: mat-palette($mat-green, A400);
$indigo-dark: mat-palette($mat-indigo, A200);
$purple-dark: mat-palette($mat-purple, A700);
$amber-dark: mat-palette($mat-amber, A400);
$teal-dark: mat-palette($mat-teal, A400);

/*-- Light Theme Colors --*/
$green-light: mat-palette($mat-green, A700);
$indigo-light: mat-palette($mat-indigo, A400);
$purple-light: mat-palette($mat-purple, 700);
$amber-light: mat-palette($mat-amber, A700);
$teal-light: mat-palette($mat-teal, A700);

@mixin elevate ($dp) {
  @if $dp==0 {
    box-shadow: none;
    -webkit-box-shadow: none;
  }

  @else if $dp==1 {
    box-shadow: 0 1px 1px 0 rgba(0, 0, 0, .14), 0 2px 1px -1px rgba(0, 0, 0, .12), 0 1px 3px 0 rgba(0, 0, 0, .20);
    -webkit-box-shadow: 0 1px 1px 0 rgba(0, 0, 0, .14), 0 2px 1px -1px rgba(0, 0, 0, .12), 0 1px 3px 0 rgba(0, 0, 0, .20);
  }

  @else if $dp==2 {
    box-shadow: 0 2px 2px 0 rgba(0, 0, 0, .14), 0 3px 1px -2px rgba(0, 0, 0, .12), 0 1px 5px 0 rgba(0, 0, 0, .20);
    -webkit-box-shadow: 0 2px 2px 0 rgba(0, 0, 0, .14), 0 3px 1px -2px rgba(0, 0, 0, .12), 0 1px 5px 0 rgba(0, 0, 0, .20);
  }

  @else if $dp==3 {
    box-shadow: 0 3px 4px 0 rgba(0, 0, 0, .14), 0 3px 3px -2px rgba(0, 0, 0, .12), 0 1px 8px 0 rgba(0, 0, 0, .20);
    -webkit-box-shadow: 0 3px 4px 0 rgba(0, 0, 0, .14), 0 3px 3px -2px rgba(0, 0, 0, .12), 0 1px 8px 0 rgba(0, 0, 0, .20);
  }

  @else if $dp==4 {
    box-shadow: 0 4px 5px 0 rgba(0, 0, 0, .14), 0 1px 10px 0 rgba(0, 0, 0, .12), 0 2px 4px -1px rgba(0, 0, 0, .20);
    -webkit-box-shadow: 0 4px 5px 0 rgba(0, 0, 0, .14), 0 1px 10px 0 rgba(0, 0, 0, .12), 0 2px 4px -1px rgba(0, 0, 0, .20);
  }

  @else if $dp==6 {
    box-shadow: 0 6px 10px 0 rgba(0, 0, 0, .14), 0 1px 18px 0 rgba(0, 0, 0, .12), 0 3px 5px -1px rgba(0, 0, 0, .20);
    -webkit-box-shadow: 0 6px 10px 0 rgba(0, 0, 0, .14), 0 1px 18px 0 rgba(0, 0, 0, .12), 0 3px 5px -1px rgba(0, 0, 0, .20);
  }

  @else if $dp==8 {
    box-shadow: 0 8px 10px 1px rgba(0, 0, 0, .14), 0 3px 14px 2px rgba(0, 0, 0, .12), 0 5px 5px -3px rgba(0, 0, 0, .20);
    -webkit-box-shadow: 0 8px 10px 1px rgba(0, 0, 0, .14), 0 3px 14px 2px rgba(0, 0, 0, .12), 0 5px 5px -3px rgba(0, 0, 0, .20);
  }

  @else if $dp==9 {
    box-shadow: 0 9px 12px 1px rgba(0, 0, 0, .14), 0 3px 16px 2px rgba(0, 0, 0, .12), 0 5px 6px -3px rgba(0, 0, 0, .20);
    -webkit-box-shadow: 0 9px 12px 1px rgba(0, 0, 0, .14), 0 3px 16px 2px rgba(0, 0, 0, .12), 0 5px 6px -3px rgba(0, 0, 0, .20);
  }

  @else if $dp==12 {
    box-shadow: 0 12px 17px 2px rgba(0, 0, 0, .14), 0 5px 22px 4px rgba(0, 0, 0, .12), 0 7px 8px -4px rgba(0, 0, 0, .20);
    -webkit-box-shadow: 0 12px 17px 2px rgba(0, 0, 0, .14), 0 5px 22px 4px rgba(0, 0, 0, .12), 0 7px 8px -4px rgba(0, 0, 0, .20);
  }

  @else if $dp==16 {
    box-shadow: 0 16px 24px 2px rgba(0, 0, 0, .14), 0 6px 30px 5px rgba(0, 0, 0, .12), 0 8px 10px -5px rgba(0, 0, 0, .20);
    -webkit-box-shadow: 0 16px 24px 2px rgba(0, 0, 0, .14), 0 6px 30px 5px rgba(0, 0, 0, .12), 0 8px 10px -5px rgba(0, 0, 0, .20);
  }

  @else if $dp==24 {
    box-shadow: 0 24px 38px 3px rgba(0, 0, 0, .14), 0 9px 46px 8px rgba(0, 0, 0, .12), 0 11px 15px -7px rgba(0, 0, 0, .20);
    -webkit-box-shadow: 0 24px 38px 3px rgba(0, 0, 0, .14), 0 9px 46px 8px rgba(0, 0, 0, .12), 0 11px 15px -7px rgba(0, 0, 0, .20);
  }
}
